# Record Class SyEmbossedRectangle<T extends SySpaceType>

java.lang.Object
java.lang.Record
com.io7m.jsycamore.api.rendering.SyEmbossedRectangle<T>

Type Parameters:
  `T` - The coordinate space
Record Components:
  `fillNorth` - The north paint
  `shapeNorth` - The north shape
  `fillEast` - The east paint
  `shapeEast` - The east shape
  `fillSouth` - The south paint
  `shapeSouth` - The south shape
  `fillWest` - The west paint
  `shapeWest` - The west shape

public record SyEmbossedRectangle<T extends SySpaceType>(SyPaintFillType fillNorth, SyShapePolygon<T extends SySpaceType> shapeNorth, SyPaintFillType fillEast, SyShapePolygon<T extends SySpaceType> shapeEast, SyPaintFillType fillSouth, SyShapePolygon<T extends SySpaceType> shapeSouth, SyPaintFillType fillWest, SyShapePolygon<T extends SySpaceType> shapeWest) extends Record
The embossed parts of an embossed rectangle.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SyEmbossedRectangle(SyPaintFillType fillNorth, SyShapePolygon<T> shapeNorth, SyPaintFillType fillEast, SyShapePolygon<T> shapeEast, SyPaintFillType fillSouth, SyShapePolygon<T> shapeSouth, SyPaintFillType fillWest, SyShapePolygon<T> shapeWest)`
  The embossed parts of an embossed rectangle.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static <T extends SySpaceType>
  SyEmbossedRectangle<T>`
  `emboss(com.io7m.jregions.core.parameterized.areas.PAreaI<T> area, SyPaintFillType fillNorth, SyPaintFillType fillEast, SyPaintFillType fillSouth, SyPaintFillType fillWest, int edgeOffset, int embossThickness)`
  Emboss a rectangle.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `SyPaintFillType`
  `fillEast()`
  Returns the value of the `fillEast` record component.
  `SyPaintFillType`
  `fillNorth()`
  Returns the value of the `fillNorth` record component.
  `SyPaintFillType`
  `fillSouth()`
  Returns the value of the `fillSouth` record component.
  `SyPaintFillType`
  `fillWest()`
  Returns the value of the `fillWest` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `SyShapePolygon<T>`
  `shapeEast()`
  Returns the value of the `shapeEast` record component.
  `SyShapePolygon<T>`
  `shapeNorth()`
  Returns the value of the `shapeNorth` record component.
  `SyShapePolygon<T>`
  `shapeSouth()`
  Returns the value of the `shapeSouth` record component.
  `SyShapePolygon<T>`
  `shapeWest()`
  Returns the value of the `shapeWest` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### SyEmbossedRectangle

    public SyEmbossedRectangle(SyPaintFillType fillNorth, SyShapePolygon<T> shapeNorth, SyPaintFillType fillEast, SyShapePolygon<T> shapeEast, SyPaintFillType fillSouth, SyShapePolygon<T> shapeSouth, SyPaintFillType fillWest, SyShapePolygon<T> shapeWest)
    The embossed parts of an embossed rectangle.
    Parameters:
      `fillNorth` - The north paint
      `shapeNorth` - The north shape
      `fillEast` - The east paint
      `shapeEast` - The east shape
      `fillSouth` - The south paint
      `shapeSouth` - The south shape
      `fillWest` - The west paint
      `shapeWest` - The west shape

- ## Method Details

  - ### emboss

    public static <T extends SySpaceType> SyEmbossedRectangle<T> emboss(com.io7m.jregions.core.parameterized.areas.PAreaI<T> area, SyPaintFillType fillNorth, SyPaintFillType fillEast, SyPaintFillType fillSouth, SyPaintFillType fillWest, int edgeOffset, int embossThickness)
    Emboss a rectangle.
    Type Parameters:
      `T` - The coordinate space
    Parameters:
      `area` - The rectangle area
      `fillNorth` - The north paint
      `fillEast` - The east paint
      `fillSouth` - The south paint
      `fillWest` - The west paint
      `edgeOffset` - The edge offset for the embossed parts
      `embossThickness` - The thickness of the embossed parts
    Returns:
      An embossed rectangle

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### fillNorth

    public SyPaintFillType fillNorth()
    Returns the value of the `fillNorth` record component.
    Returns:
      the value of the `fillNorth` record component

  - ### shapeNorth

    public SyShapePolygon<T> shapeNorth()
    Returns the value of the `shapeNorth` record component.
    Returns:
      the value of the `shapeNorth` record component

  - ### fillEast

    public SyPaintFillType fillEast()
    Returns the value of the `fillEast` record component.
    Returns:
      the value of the `fillEast` record component

  - ### shapeEast

    public SyShapePolygon<T> shapeEast()
    Returns the value of the `shapeEast` record component.
    Returns:
      the value of the `shapeEast` record component

  - ### fillSouth

    public SyPaintFillType fillSouth()
    Returns the value of the `fillSouth` record component.
    Returns:
      the value of the `fillSouth` record component

  - ### shapeSouth

    public SyShapePolygon<T> shapeSouth()
    Returns the value of the `shapeSouth` record component.
    Returns:
      the value of the `shapeSouth` record component

  - ### fillWest

    public SyPaintFillType fillWest()
    Returns the value of the `fillWest` record component.
    Returns:
      the value of the `fillWest` record component

  - ### shapeWest

    public SyShapePolygon<T> shapeWest()
    Returns the value of the `shapeWest` record component.
    Returns:
      the value of the `shapeWest` record component